<?php

$defblog_id=get_blog_option(SITE_ID_CURRENT_SITE,'defblog_id');

// Setting default blog id
function update_default_blog($defblog_id){
	update_blog_option (SITE_ID_CURRENT_SITE,'defblog_id', $defblog_id, true);
}
// Updating posts
function update_posts($posts,$delet_existing=false){
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_posts', $posts, true);
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_posts_delete', $delet_existing, true);
}
// Updating pages
function update_pages($pages,$delet_existing=false){
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_pages', $pages, true);
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_pages_delete', $delet_existing, true);
}
// Updating links
function update_links($links,$delet_existing=false){
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_links', $links, true);
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_link_delete', $delet_existing, true);
}
// Updating categories
function update_cats($cats,$delet_existing=false){
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_cats', $cats, true);
	update_blog_option(SITE_ID_CURRENT_SITE,'default_blog_cats_delete', $delet_existing, true);
}
// Updating Options
function update_options($options){
	update_blog_option(SITE_ID_CURRENT_SITE,'global_blog_options', $options, true);
}
// Updating links of new blog
function copy_links(){
	global $wpdb;
	global $blog_id;
	global $defblog_id;
	
	$link_fields=array('link_url','link_name','link_image','link_target','link_description','link_visible','link_updated','link_rel','link_notes','link_rss');
	
	// Getting default blog settings
	$links=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_links');
	$default_blog_link_delete=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_link_delete');
	
	if($default_blog_link_delete==true){
		$sql="TRUNCATE TABLE wp_".$blog_id."_links";
		$wpdb->query($sql);
	}
	
	// Adding links
	if(is_array($links)){
		foreach($links AS $link){
				$sql="SELECT * FROM wp_".$defblog_id."_links WHERE link_id='".$link."'";
				$default_link = $wpdb->get_row($sql, ARRAY_A);
				$sql_old=$sql;
				
				$sql="INSERT INTO wp_".$blog_id."_links ";
				$i=0;
	
				foreach($link_fields AS $link_field){
					if($i==0){
						$sql_fields=$link_field;
						$sql_values="'".$default_link[$link_field]."'";
					}else{
						$sql_fields.=",".$link_field;
						$sql_values.=",'".$default_link[$link_field]."'";
					}
					$i++;
				}
				$sql.="(".$sql_fields.") VALUES (".$sql_values.")";
				$wpdb->query($sql);
		}
	}
}

// Updating posts of new blog
function copy_posts(){
	global $blog_id;
	global $defblog_id;

	$post_fields=array('post_author','post_date','post_date_gmt','post_content','post_title','post_excerpt','post_status','comment_status','ping_status','post_password','post_name','to_ping','pinged','post_modified','post_modified_gmt','post_content_filtered','post_parent','guid','menu_order','post_type','post_mime_type','comment_count');
	// Getting default blog settings
	$posts=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_posts');
	$default_blog_posts_delete=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_posts_delete');
	
	// Deleting old posts
	if($default_blog_posts_delete==true){
		$del_posts=get_posts("numberposts=-1&post_status=''&post_type=any");
					
		foreach($del_posts AS $del_post){
			wp_delete_post($del_post->ID);
		}
	}

	switch_to_blog($defblog_id);
	$new_posts=get_posts("numberposts=-1&include=".implode(",",$posts)."&post_status=''&post_type=any");
	restore_current_blog();
	
	// Adding posts
	if(is_array($new_posts)){
		$post_changes="";
		
		// Adding pages
		foreach($new_posts AS $new_post){
			$old_post_id=$new_post->ID;
			$new_post->ID="";						
			$new_post_id=wp_insert_post($new_post);
			
			$post_changes[$old_post_id]=$new_post_id;	

			// Adding post_metas
			switch_to_blog($defblog_id);
			$custom_keys=get_post_custom_keys($old_post_id);
			restore_current_blog();
			
			foreach($custom_keys AS $custom_key){
				
				switch_to_blog($defblog_id);
		  		$post_metas=get_post_meta($old_post_id, $custom_key);
		  		restore_current_blog();
		  		
		  		foreach($post_metas AS $post_meta){
		  			update_post_meta($new_post_id, $custom_key, $post_meta);
		  		} 		  		
		  	}
			
		}
	}
}
// Updating pages of new blog
function copy_pages(){
	global $blog_id;
	global $defblog_id;
	
	// Getting default blog settings
	$pages=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_pages');
	$default_blog_pages_delete=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_pages_delete');
	
	// Deleting old pages
	if($default_blog_pages_delete==true){
		$args = array(
		    'child_of' => 0,
		    'hierarchical' => 0,
		    'parent' => -1,
		    'offset' => 0 
		);
		$del_pages=get_pages($args);
			
		foreach($del_pages AS $del_page){
			wp_delete_post($del_page->ID);
		}
	}
	
	// Getting new pages from default blog
	switch_to_blog($defblog_id);
	$new_pages=get_pages("include=".implode(",",$pages));
	restore_current_blog();
	
	// Adding pages
	if(is_array($new_pages)){
		$page_changes="";
		
		// Adding pages
		foreach($new_pages AS $new_page){
			
			$old_page_id=$new_page->ID;
			$new_page->ID="";						
			$new_page_id=wp_insert_post($new_page);
			
			$page_changes[$old_page_id]=$new_page_id;			
			
			// Adding post_metas
			switch_to_blog($defblog_id);
			$custom_keys=get_post_custom_keys($old_page_id);
			restore_current_blog();
			
			foreach($custom_keys AS $custom_key){
				
				switch_to_blog($defblog_id);
		  		$post_metas=get_post_meta($old_page_id, $custom_key);
		  		restore_current_blog();
		  		
		  		// print_r($post_metas);
		  		
		  		foreach($post_metas AS $post_meta){
		  			update_post_meta($new_page_id, $custom_key, $post_meta);
		  		} 		  		
		  	}
		}
		
		// Seting up parent pages
		$args = array(
		    'child_of' => 0,
		    'hierarchical' => 0,
		    'parent' => -1,
		    'offset' => 0 
		);
		$update_pages=get_pages($args);
		
		foreach($update_pages AS $update_page){
			if($update_page->post_parent!=0){
				$update_page->post_parent=$page_changes[$update_page->post_parent];
				wp_update_post($update_page);
			}
		}

	}
}
// Updating categories of new blog
function copy_cats(){
	global $blog_id;
	global $defblog_id;
	
	
	// Getting default blog settings
	$cats=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_cats');
	$default_blog_cats_delete=get_blog_option(SITE_ID_CURRENT_SITE,'default_blog_cats_delete');
	
	if($default_blog_cats_delete==true){
		$args = array(
	    'type'                     => 'post',
	    'child_of'                 => 0,
	    'orderby'                  => 'name',
	    'order'                    => 'ASC',
	    'hide_empty'               => false,
	    'pad_counts'               => false );
		
  		$del_cats=get_categories($args);
  		
  		foreach($del_cats as $del_cat){
  			wp_delete_category($del_cat->cat_ID);
  		}
	}
	
	$args = array(
	    'type'                     => 'post',
		'include'				   => implode(",",$cats),
	    'child_of'                 => 0,
	    'orderby'                  => 'name',
	    'order'                    => 'ASC',
	    'hide_empty'               => false,
	    'pad_counts'               => false );
	
	switch_to_blog($defblog_id);
	$cats_new=get_categories($args);
  	restore_current_blog();	
	
	// Adding pages
	if(is_array($cats_new)){
		foreach($cats_new AS $cat_new){
			$cat_args = array(
			  'cat_name' => $cat_new->cat_name,
			  'category_description' => $cat_new->category_description,
			  'category_nicename' => $cat_new->category_nicename,
			  'category_parent' => $cat_new->category_parent,
			  'slug' => $cat_new->slug
			);
			wp_insert_category($cat_args);
		}
	}
}
// Updating options of new blog
function copy_options(){
	global $defblog_id;
	
	$options=get_blog_option(SITE_ID_CURRENT_SITE,'global_blog_options');
	if(is_array($options)){
		foreach($options AS $option){
			update_option($option,get_blog_option($defblog_id,$option));
		}
	}
}
?>